Merge "Customize scheduler_default_filters (nova.conf)"
[apex-tripleo-heat-templates.git] / extraconfig / tasks / yum_update.sh
index e74c4d8..b045e5e 100755 (executable)
@@ -18,15 +18,14 @@ fi
 timestamp_dir=/var/lib/overcloud-yum-update
 mkdir -p $timestamp_dir
 
-command_arguments=${command_arguments:-}
-# exclude upgrading packages that are handled by config management tooling
-for exclude in $(cat /var/lib/tripleo/installed-packages/* | sort -u); do
-  command_arguments="$command_arguments --exclude $exclude"
-done
-
 # sanitise to remove unusual characters
 update_identifier=${update_identifier//[^a-zA-Z0-9-_]/}
 
+# seconds to wait for this node to rejoin the cluster after update
+cluster_start_timeout=600
+galera_sync_timeout=1800
+cluster_settle_timeout=1800
+
 timestamp_file="$timestamp_dir/$update_identifier"
 if [[ -a "$timestamp_file" ]]; then
     echo "Not running for already-run timestamp \"$update_identifier\""
@@ -34,8 +33,36 @@ if [[ -a "$timestamp_file" ]]; then
 fi
 touch "$timestamp_file"
 
+command_arguments=${command_arguments:-}
+
+list_updates=$(yum list updates)
+
+if [[ "$list_updates" == "" ]]; then
+    echo "No packages require updating"
+    exit 0
+fi
+
+pacemaker_status=$(systemctl is-active pacemaker)
+
+if [[ "$pacemaker_status" == "active" ]] ; then
+    echo "Pacemaker running, stopping cluster node and doing full package update"
+    node_count=$(pcs status xml | grep -o "<nodes_configured.*/>" | grep -o 'number="[0-9]*"' | grep -o "[0-9]*")
+    if [[ "$node_count" == "1" ]] ; then
+        echo "Active node count is 1, stopping node with --force"
+        pcs cluster stop --force
+    else
+        pcs cluster stop
+    fi
+else
+    echo "Upgrading openstack-puppet-modules"
+    yum -q -y update openstack-puppet-modules
+    echo "Upgrading other packages is handled by config management tooling"
+    echo -n "true" > $heat_outputs_path.update_managed_packages
+    exit 0
+fi
+
 command=${command:-update}
-full_command="yum -y $command $command_arguments"
+full_command="yum -q -y $command $command_arguments"
 echo "Running: $full_command"
 
 result=$($full_command)
@@ -43,7 +70,40 @@ return_code=$?
 echo "$result"
 echo "yum return code: $return_code"
 
-echo -n "true" > $heat_outputs_path.update_managed_packages
+if [[ "$pacemaker_status" == "active" ]] ; then
+    echo "Starting cluster node"
+    pcs cluster start
+
+    hostname=$(hostname -s)
+    tstart=$(date +%s)
+    while [[ "$(pcs status | grep "^Online" | grep -F -o $hostname)" == "" ]]; do
+        sleep 5
+        tnow=$(date +%s)
+        if (( tnow-tstart > cluster_start_timeout )) ; then
+            echo "ERROR $hostname failed to join cluster in $cluster_start_timeout seconds"
+            pcs status
+            exit 1
+        fi
+    done
+
+    tstart=$(date +%s)
+    while ! clustercheck; do
+        sleep 5
+        tnow=$(date +%s)
+        if (( tnow-tstart > galera_sync_timeout )) ; then
+            echo "ERROR galera sync timed out"
+            exit 1
+        fi
+    done
+
+    echo "Waiting for pacemaker cluster to settle"
+    if ! timeout -k 10 $cluster_settle_timeout crm_resource --wait; then
+        echo "ERROR timed out while waiting for the cluster to settle"
+        exit 1
+    fi
+
+    pcs status
+fi
 
 echo "Finished yum_update.sh on server $deploy_server_id at `date`"